<template>
  <user-dashboard-container page-class="post agent-requests-details" panel-title="فرم گزارش عملکرد گارانتی">
    <el-alert v-if="guaranteeReport.status === 'temp'" :title="alertMsg" class="mb-3" type="warning"> </el-alert>
    <form class="form form_3">
      <div class="userInfo">
        <div class="formRow">
          <label for="customer_name">نام و نام خانوادگی:</label>
          <input id="customer_name" type="text" :value="guaranteeReport.agent_id.full_name" disabled />
        </div>
        <div class="formRow">
          <label for="customer_code">کد نمایندگی:</label>
          <input id="customer_code" type="text" :value="guaranteeReport.agent_id.agent_code" disabled />
        </div>
        <div class="formRow">
          <label for="mobile">شماره موبایل:</label>
          <input id="mobile" type="text" :value="guaranteeReport.agent_id.mobile_number" disabled />
        </div>
        <div class="formRow">
          <label for="fax">شماره فکس:</label>
          <input id="fax" type="text" :value="guaranteeReport.agent_id.fax_number" disabled />
        </div>
        <div class="formRow">
          <label for="province">استان:</label>
          <input id="province" type="text" :value="guaranteeReport.agent_id.province_name" disabled />
        </div>
        <div class="formRow">
          <label for="city">شهر:</label>
          <input id="city" type="text" :value="guaranteeReport.agent_id.city_name" disabled />
        </div>
      </div>

      <div class="formRow">
        <label>آدرس:</label>
        <textarea name="description" cols="30" rows="5" disabled :value="guaranteeReport.agent_id.address"></textarea>
      </div>

      <hr />

      <div class="formRow">
        <label v-if="guaranteeReport.status === 'temp'" for="description">توضیحات فرم (اختیاری):</label>
        <label v-else for="description">توضیحات فرم:</label>
        <el-tooltip
          v-model="descriptionTooltip"
          class="item"
          effect="dark"
          content="میتوانید توضیحات را در هر زمان تغییر دهید"
          placement="top-start"
          :disabled="guaranteeReport.status !== 'temp'"
        >
          <textarea
            id="description"
            v-model="guaranteeReport.description"
            name="description"
            :disabled="guaranteeReport.status !== 'temp'"
            :placeholder="descriptionPlaceHolder"
            cols="30"
            rows="10"
            @blur="updateDescription"
          ></textarea>
        </el-tooltip>
      </div>
    </form>

    <div class="notes">
      <h3>توجه:</h3>
      <ul>
        <li>
          <p>مدارک گارانتی فقط تا سه ماه بعد از تاریخ پذیرش دستگاه اعتبار دارد.</p>
        </li>
        <li>
          <p>هر سه ماه یک بار مدارک گارانتی خود را جهت تسویه حساب به همراه داغی قطعات ارسال نمایید.</p>
        </li>
      </ul>
    </div>

    <div class="add-list">
      <h2>لیست قطعات درخواستی:</h2>
      <div class="tableBox">
        <table class="report-items">
          <thead>
            <tr>
              <th class="index">ردیف</th>

              <th class="customerName">نام مشتری</th>
              <th class="customerTel">تلفن مشتری</th>
              <th class="itemName">نام کالا</th>
              <th class="itemSerial">سریال گارانتی</th>

              <th class="productIssue">ایراد کالا</th>
              <th class="usedPieces">قطعات مصرفی</th>

              <th class="recieveDate">تاریخ دریافت</th>
              <th class="deliverDate">تاریخ تحویل</th>
              <th v-if="guaranteeReport.status === 'temp'" class="removeBtn">حذف</th>
            </tr>
          </thead>

          <tbody>
            <tr
              v-for="(item, index) in guaranteeReport.items"
              :key="item.ItemID + index + '_gr_reports'"
              :title="item.ItemName + ' - ' + item.pieceName"
            >
              <td class="index">
                <span>{{ index + 1 }}</span>
              </td>

              <td class="customerName">
                <span>{{ item.customerName }}</span>
              </td>

              <td class="customerTel">
                <span>{{ item.customerTel }}</span>
              </td>

              <td class="itemName">
                <span>{{ item.ItemName }}</span>
              </td>

              <td class="itemSerial">
                <span>{{ item.SerialNo1 || '-' }}</span>
              </td>

              <td class="productIssue">
                <span> {{ item.productIssue }} </span>
              </td>

              <td class="usedPieces">
                <span> {{ item.usedPieces }} </span>
              </td>

              <td class="recieveDate">
                <span> {{ $jDate(item.recieveDate) }} </span>
              </td>
              <td class="deliverDate">
                <span> {{ $jDate(item.deliverDate) }} </span>
              </td>

              <td v-if="guaranteeReport.status === 'temp'" class="removeBtn">
                <button class="trashIcon-btn" title="حذف پیشنویس" @click="removeItemFromList(item._id)">
                  <i class="fal fa-trash-alt"></i>
                </button>
              </td>
            </tr>

            <tr v-if="!guaranteeReport.items.length" class="odd">
              <td class="noItem" colspan="5">
                <p style="color: #000">هنوز هیچ آیتمی اضافه نکردید.</p>
              </td>
            </tr>

            <tr v-if="guaranteeReport.status === 'temp'" class="addStuffBtn" @click="reportModal = true">
              <td colspan="5">
                <button>
                  <span>افزودن گزارش</span>
                  <i class="far fa-plus"></i>
                </button>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
      <table-notice />

      <hr />

      <div v-if="guaranteeReport.status === 'temp'" class="btnRow">
        <button class="btn btn-primary" @click="sendForm">ارسال به آسان سرویس</button>
        <button class="btn btn-danger" @click="removeGR">حذف این فرم</button>
      </div>
    </div>

    <template #body>
      <AddReportToGuaranteeReportForm
        :key="reportModalKey"
        :show="reportModal"
        :gr-id="guaranteeReport._id"
        @closeModal="closeReportModal"
      />
    </template>
  </user-dashboard-container>
</template>

<script>
export default {
  name: 'AccountAgentGrDetails',
  layout: 'user',
  async asyncData({ $axios, params, error }) {
    try {
      const guaranteeReport = await $axios.get(`/api/agent/gr/${params.gr}`)
      return {
        guaranteeReport: guaranteeReport.data
      }
    } catch (e) {
      error({ status: 404, message: 'There is a problem here' })
    }
  },
  data() {
    return {
      guaranteeReport: null,
      validation: {},
      reportModal: false,
      reportModalKey: 0,
      descriptionTooltip: false,
      alertMsg:
        'این فرم گزارش عملکرد در پیشنویس ها ذخیره شده و هنوز  در پایگاه داده شرکت آسان سرویس ثبت نگردیده. شما میتوانید گزارش ها را در هر زمان به این فرم اضافه یا از فرم حذف کنید سپس نسبت به ارسال نهایی اقدام کنید.'
    }
  },
  computed: {
    grId() {
      return this.$route.params.gr
    },
    descriptionPlaceHolder() {
      if (this.guaranteeReport.status === 'temp') return 'توضیحات راجع به فرم گزارش را میتوانید اینجا بنویسید'
      else return 'بدون توضیحات'
    }
  },
  mounted() {
    setTimeout(() => {
      if (this.guaranteeReport.status === 'temp') this.descriptionTooltip = true
    }, 1000)
  },
  methods: {
    closeReportModal() {
      this.reportModal = false
      this.reportModalKey = Math.random()
    },
    removeItemFromList(id) {
      if (this.guaranteeReport.status !== 'temp') return
      this.$confirm('این مورد حذف شود؟', 'هشدار', {
        confirmButtonText: 'بله',
        cancelButtonText: 'لغو',
        type: 'warning'
      })
        .then(() => {
          this.$axios
            .delete(`/api/agent/removeGrItems/${id}`)
            .then(res => {
              this.$message({
                type: 'success',
                message: res.data.message
              })
              this.$nuxt.refresh()
            })
            .catch(() => {
              this.$message({
                type: 'error',
                message: 'مشکلی در انجام عملیات پیش آمده'
              })
            })
        })
        .catch(() => {
          this.$message({
            type: 'warning',
            message: 'عملیات لغو شد'
          })
        })
    },
    updateDescription() {
      if (this.guaranteeReport.status !== 'temp') return
      const data = { description: this.guaranteeReport.description }
      this.$axios
        .put(`/api/agent/grDescription/${this.grId}`, data)
        .then(res => {
          this.$message({
            type: 'success',
            message: res.data.message
          })
        })
        .catch(() => {
          this.$message({
            type: 'error',
            message: 'مشکلی در ثبت اطلاعات پیش آمده'
          })
        })
    },
    sendForm() {
      this.$confirm('فرم گزارش عملکرد گارانتی به آسان سرویس ارسال شود؟', 'هشدار', {
        confirmButtonText: 'بله',
        cancelButtonText: 'لغو',
        type: 'warning'
      })
        .then(() => {
          this.$axios
            .post(`/api/agent/sendGr/${this.grId}`)
            .then(res => {
              this.$message({
                type: 'success',
                message: res.data.message
              })
              this.$router.push({ name: 'account-agents-guaranteeReports', query: { type: 'sent' } })
            })
            .catch(err => {
              let msg = 'مشکلی در ارسال گزارش پیش آمده'
              if (err.response.status === 406) msg = err.response.data.message
              this.$message({
                type: 'error',
                message: msg
              })
            })
        })
        .catch(() => {
          this.$message({
            type: 'warning',
            message: 'عملیات لغو شد'
          })
        })
    },
    removeGR() {
      this.$confirm('این فرم از پیشنویس ها حذف شود؟', 'هشدار', {
        confirmButtonText: 'بله',
        cancelButtonText: 'لغو',
        type: 'warning'
      })
        .then(() => {
          this.$axios
            .delete(`/api/agent/gr/${this.grId}`)
            .then(res => {
              this.$message({
                type: 'success',
                message: res.data.message
              })
              this.$router.push({ name: 'account-agents-guaranteeReports', query: { type: 'temp' } })
            })
            .catch(() => {
              this.$message({
                type: 'error',
                message: 'مشکلی در حذف پیشنویس پیش آمده'
              })
            })
        })
        .catch(() => {
          this.$message({
            type: 'warning',
            message: 'عملیات لغو شد'
          })
        })
    }
  }
}
</script>
